package com.example.austime.Dessin;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class BucketView extends SurfaceView implements Runnable {

    final static int MAX = 300;
    volatile boolean isStarted = false;
    static int time = MAX;

    private SurfaceHolder surfaceHolder;
    private Thread t = null;


    public BucketView(Context context) {
        super(context);

        surfaceHolder = getHolder();

        TopChrono();

        init();

        t = new Thread(this);
        t.start();

    }

    public BucketView(Context context, AttributeSet attrs) {
        super(context, attrs);

        surfaceHolder = getHolder();

        TopChrono();

        init();

        t = new Thread(this);
        t.start();
    }

    public BucketView(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);

        surfaceHolder = getHolder();

        TopChrono();

        init();

        t = new Thread(this);
        t.start();
    }

    protected void drawing(Canvas canvas){
        if(canvas!=null)
        {
            canvas.drawColor(Color.WHITE);

            int height = canvas.getHeight();
            int width = canvas.getWidth();

            float quarterHeight = height/4;
            float quarterWidth = width/4;

            float squarelenght = width/2;


            Paint paintWater = new Paint();
            paintWater.setColor(Color.rgb(160,200,200));
            paintWater.setStrokeWidth(1);
            paintWater.setStyle(Paint.Style.FILL);

            Paint paintBouchon = new Paint();
            paintBouchon.setColor(Color.rgb(180,100,100));
            paintBouchon.setStrokeWidth(3);
            paintBouchon.setStyle(Paint.Style.FILL);

            Paint paint = new Paint();
            paint.setColor(Color.BLACK);
            paint.setStrokeWidth(10);
            paint.setStyle(Paint.Style.STROKE);

            //TEST
            /*
            canvas.drawLine(quarterWidth,
                    quarterHeight,
                    quarterWidth*3,
                    quarterHeight*3,
                    paint);

            canvas.drawRect(quarterWidth,
                    quarterHeight,
                    quarterWidth*3,
                    quarterHeight*3,
                    paint);
*/
            /* Eau (pleine)*/
            canvas.drawRect(quarterWidth,
                    height/2 - quarterWidth,
                    quarterWidth*3,
                    (height/2) + quarterWidth,
                    paintWater);


            /*Line gauche, bas, puis droite*/
            canvas.drawLine(quarterWidth,
                    height/2 - quarterWidth,
                    quarterWidth,
                    (height/2) + quarterWidth,
                    paint);

            canvas.drawLine(quarterWidth,
                    height/2 + quarterWidth,
                    quarterWidth*3,
                    (height/2) + quarterWidth,
                    paint);

            canvas.drawLine(quarterWidth*3,
                    height/2 - quarterWidth,
                    quarterWidth*3,
                    (height/2) + quarterWidth,
                    paint);

            /* BOUCHON */
            canvas.drawRect(quarterWidth,
                    (height/2) + quarterWidth,
                    quarterWidth - (quarterWidth/10),
                    (height/2) + quarterWidth - (quarterWidth/10),
            paintBouchon);

            canvas.drawLine(quarterWidth - (quarterWidth/10),
                    (height/2) + quarterWidth + (quarterWidth/10),
                    quarterWidth - (quarterWidth/10),
                    (height/2) + quarterWidth - (quarterWidth/10)*2,
                    paintBouchon);

            canvas.drawLine(quarterWidth,
                    (height/2) + quarterWidth - (quarterWidth/10),
                    quarterWidth - (quarterWidth/10),
                    (height/2) + quarterWidth - (quarterWidth/10)*2,
                    paintBouchon);

            canvas.drawLine(quarterWidth,
                    (height/2) + quarterWidth,
                    quarterWidth - (quarterWidth/10),
                    (height/2) + quarterWidth + (quarterWidth/10),
                    paintBouchon);





        }
        else
        {
            Log.e("Error Canvas Null", "Canvas null");
        }
    }

    private boolean verifIsStarted(){
        return this.time > 0 && this.isStarted;
    }

    private void init(){
        getHolder().addCallback(new SurfaceHolder.Callback() {

            @Override
            public void surfaceCreated(SurfaceHolder holder) {
                //r = new Route();
                Canvas canvas = holder.lockCanvas(null);
                drawing(canvas);
                holder.unlockCanvasAndPost(canvas);
            }

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
                // TODO Auto-generated method stub
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder holder) {
                // TODO Auto-generated method stub
            }
        });
    }

    @Override
    public void run() {
        while(this.isStarted) {
            if(getHolder().getSurface().isValid()) {
                Canvas canvas = getHolder().lockCanvas();

                if(canvas!=null)
                {
                    drawing(canvas);
                }
                else
                {
                    System.out.println("Canvas null 2");
                }

                getHolder().unlockCanvasAndPost(canvas);
                try {
                    Thread.sleep(5);
                } catch (InterruptedException e) {

                    Log.e("Tag", "J'AI PLANTER LOL");
                    e.printStackTrace();
                    Thread.currentThread().interrupt();
                    this.isStarted = false;
                    return;
                }
            }
        }
    }

    void TopChrono(){
        this.isStarted = true;
    }
}
